#!/usr/bin/python
# vim: set expandtab tabstop=4 shiftwidth=4:
#
# UQM Starmap Viewer
# Copyright (C) 2009 CJ Kucera
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

import cPickle
import MySQLdb
import ConfigParser

# This tiny app doesn't really do anyone any good except for me.  I had
# pulled the map data from UQM into a MySQL database and stored it there
# for awhile - originally the starmap viewer was actually going to do
# all of its filtering and stuff via SQL, though when I started the project
# I never did more than the basic SELECTs you see below, and then did
# all the work via the classes, like the app still does.  Then when I
# thought about the fact that I may want to distribute this somehow, having
# a MySQL dependency was just ludicrous.  So, I ripped out what little
# there was of the DB connectivity and slapped it in here, exporting the
# data to a Pickle object instead, which is how the main app reads it.
#
# ... I know you TOTALLY care about all that.  Anyway, it's here for
# posterity, in case anyone was wondering how the initial pickle had been
# generated.

cp = ConfigParser.ConfigParser()
cp.read('dbinfo.txt')

dbconn = MySQLdb.connect(host = cp.get('db', 'host'),
        user = cp.get('db', 'user'),
        passwd = cp.get('db', 'pass'),
        db = cp.get('db', 'db'))
dbcurs = dbconn.cursor(MySQLdb.cursors.DictCursor)

data = {}

dbcurs.execute('select * from system')
data['systems'] = dbcurs.fetchall()

dbcurs.execute('select * from planet')
data['planets'] = dbcurs.fetchall()

dbcurs.close()
dbconn.close()

df = open('data.pickle', 'w')
cPickle.dump(data, df)
df.close()
